/[gentoo-x86]/eclass/haskell-cabal.eclass
Gentoo

Contents of /eclass/haskell-cabal.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.35 - (hide annotations) (download)
Fri Nov 16 15:47:17 2012 UTC (2 years, 1 month ago) by slyfox
Branch: MAIN
Changes since 1.34: +21 -3 lines
Restore dynamic linking of Cabal's ./setup and add building of shared libraries for ghc-7.7+.

1 slyfox 1.26 # Copyright 1999-2012 Gentoo Foundation
2 kosmikus 1.1 # Distributed under the terms of the GNU General Public License v2
3 slyfox 1.35 # $Header: /var/cvsroot/gentoo-x86/eclass/haskell-cabal.eclass,v 1.34 2012/09/27 16:35:41 axs Exp $
4 vapier 1.25
5     # @ECLASS: haskell-cabal.eclass
6     # @MAINTAINER:
7     # Haskell herd <haskell@gentoo.org>
8     # @AUTHOR:
9     # Original author: Andres Loeh <kosmikus@gentoo.org>
10     # Original author: Duncan Coutts <dcoutts@gentoo.org>
11     # @BLURB: for packages that make use of the Haskell Common Architecture for Building Applications and Libraries (cabal)
12     # @DESCRIPTION:
13 kosmikus 1.1 # Basic instructions:
14     #
15     # Before inheriting the eclass, set CABAL_FEATURES to
16     # reflect the tools and features that the package makes
17     # use of.
18     #
19     # Currently supported features:
20     # haddock -- for documentation generation
21 kolmodin 1.21 # hscolour -- generation of colourised sources
22 slyfox 1.35 # hoogle -- generation of documentation search index
23 kosmikus 1.1 # alex -- lexer/scanner generator
24     # happy -- parser generator
25     # c2hs -- C interface generator
26     # cpphs -- C preprocessor clone written in Haskell
27     # profile -- if package supports to build profiling-enabled libraries
28     # bootstrap -- only used for the cabal package itself
29 dcoutts 1.3 # bin -- the package installs binaries
30     # lib -- the package installs libraries
31 kolmodin 1.16 # nocabaldep -- don't add dependency on cabal.
32 slyfox 1.23 # only used for packages that _must_ not pull the dependency
33     # on cabal, but still use this eclass (e.g. haskell-updater).
34 slyfox 1.32 # test-suite -- add support for cabal test-suites (introduced in Cabal-1.8)
35 kosmikus 1.1
36 dcoutts 1.11 inherit ghc-package multilib
37 kosmikus 1.1
38 slyfox 1.24 # @ECLASS-VARIABLE: CABAL_EXTRA_CONFIGURE_FLAGS
39     # @DESCRIPTION:
40     # User-specified additional parameters passed to 'setup configure'.
41     # example: /etc/make.conf: CABAL_EXTRA_CONFIGURE_FLAGS=--enable-shared
42     : ${CABAL_EXTRA_CONFIGURE_FLAGS:=}
43    
44 slyfox 1.27 # @ECLASS-VARIABLE: CABAL_EXTRA_BUILD_FLAGS
45     # @DESCRIPTION:
46     # User-specified additional parameters passed to 'setup build'.
47     # example: /etc/make.conf: CABAL_EXTRA_BUILD_FLAGS=-v
48     : ${CABAL_EXTRA_BUILD_FLAGS:=}
49    
50 slyfox 1.24 # @ECLASS-VARIABLE: GHC_BOOTSTRAP_FLAGS
51     # @DESCRIPTION:
52     # User-specified additional parameters for ghc when building
53     # _only_ 'setup' binary bootstrap.
54     # example: /etc/make.conf: GHC_BOOTSTRAP_FLAGS=-dynamic to make
55     # linking 'setup' faster.
56     : ${GHC_BOOTSTRAP_FLAGS:=}
57    
58 kolmodin 1.19 HASKELL_CABAL_EXPF="pkg_setup src_compile src_test src_install"
59    
60     case "${EAPI:-0}" in
61 axs 1.34 2|3|4|5) HASKELL_CABAL_EXPF+=" src_configure" ;;
62 kolmodin 1.19 *) ;;
63     esac
64    
65     EXPORT_FUNCTIONS ${HASKELL_CABAL_EXPF}
66 kosmikus 1.1
67     for feature in ${CABAL_FEATURES}; do
68     case ${feature} in
69 kolmodin 1.16 haddock) CABAL_USE_HADDOCK=yes;;
70 kolmodin 1.21 hscolour) CABAL_USE_HSCOLOUR=yes;;
71 slyfox 1.26 hoogle) CABAL_USE_HOOGLE=yes;;
72 kolmodin 1.16 alex) CABAL_USE_ALEX=yes;;
73     happy) CABAL_USE_HAPPY=yes;;
74     c2hs) CABAL_USE_C2HS=yes;;
75     cpphs) CABAL_USE_CPPHS=yes;;
76     profile) CABAL_USE_PROFILE=yes;;
77     bootstrap) CABAL_BOOTSTRAP=yes;;
78     bin) CABAL_HAS_BINARIES=yes;;
79     lib) CABAL_HAS_LIBRARIES=yes;;
80     nocabaldep) CABAL_FROM_GHC=yes;;
81 slyfox 1.32 test-suite) CABAL_TEST_SUITE=yes;;
82 dcoutts 1.3 *) CABAL_UNKNOWN="${CABAL_UNKNOWN} ${feature}";;
83 kosmikus 1.1 esac
84     done
85    
86     if [[ -n "${CABAL_USE_HADDOCK}" ]]; then
87     IUSE="${IUSE} doc"
88 slyfox 1.28 # don't require depend on itself to build docs.
89     # ebuild bootstraps docs from just built binary
90     [[ ${CATEGORY}/${PN} = "dev-haskell/haddock" ]] || DEPEND="${DEPEND} doc? ( dev-haskell/haddock )"
91 kosmikus 1.1 fi
92    
93 kolmodin 1.21 if [[ -n "${CABAL_USE_HSCOLOUR}" ]]; then
94     IUSE="${IUSE} hscolour"
95     DEPEND="${DEPEND} hscolour? ( dev-haskell/hscolour )"
96     fi
97    
98 kosmikus 1.1 if [[ -n "${CABAL_USE_ALEX}" ]]; then
99     DEPEND="${DEPEND} dev-haskell/alex"
100     fi
101    
102     if [[ -n "${CABAL_USE_HAPPY}" ]]; then
103     DEPEND="${DEPEND} dev-haskell/happy"
104     fi
105    
106     if [[ -n "${CABAL_USE_C2HS}" ]]; then
107     DEPEND="${DEPEND} dev-haskell/c2hs"
108     fi
109    
110     if [[ -n "${CABAL_USE_CPPHS}" ]]; then
111     DEPEND="${DEPEND} dev-haskell/cpphs"
112     fi
113    
114     if [[ -n "${CABAL_USE_PROFILE}" ]]; then
115     IUSE="${IUSE} profile"
116     fi
117    
118 slyfox 1.32 if [[ -n "${CABAL_TEST_SUITE}" ]]; then
119     IUSE="${IUSE} test"
120     fi
121    
122 kosmikus 1.1 # We always use a standalone version of Cabal, rather than the one that comes
123     # with GHC. But of course we can't depend on cabal when building cabal itself.
124 dcoutts 1.14 if [[ -z ${CABAL_MIN_VERSION} ]]; then
125     CABAL_MIN_VERSION=1.1.4
126     fi
127 kolmodin 1.16 if [[ -z "${CABAL_BOOTSTRAP}" && -z "${CABAL_FROM_GHC}" ]]; then
128 dcoutts 1.11 DEPEND="${DEPEND} >=dev-haskell/cabal-${CABAL_MIN_VERSION}"
129 kosmikus 1.1 fi
130    
131 dcoutts 1.3 # Libraries require GHC to be installed.
132     if [[ -n "${CABAL_HAS_LIBRARIES}" ]]; then
133 dcoutts 1.11 RDEPEND="${RDEPEND} dev-lang/ghc"
134 dcoutts 1.3 fi
135 kosmikus 1.1
136 dcoutts 1.14 # returns the version of cabal currently in use
137     _CABAL_VERSION_CACHE=""
138     cabal-version() {
139     if [[ -z "${_CABAL_VERSION_CACHE}" ]]; then
140     if [[ "${CABAL_BOOTSTRAP}" ]]; then
141     # We're bootstrapping cabal, so the cabal version is the version
142     # of this package itself.
143     _CABAL_VERSION_CACHE="${PV}"
144 kolmodin 1.17 elif [[ "${CABAL_FROM_GHC}" ]]; then
145 slyfox 1.24 local cabal_package=$(echo "$(ghc-libdir)"/Cabal-*)
146     # /path/to/ghc/Cabal-${VER} -> ${VER}
147     _CABAL_VERSION_CACHE="${cabal_package/*Cabal-/}"
148 dcoutts 1.14 else
149     # We ask portage, not ghc, so that we only pick up
150     # portage-installed cabal versions.
151     _CABAL_VERSION_CACHE="$(ghc-extractportageversion dev-haskell/cabal)"
152     fi
153     fi
154     echo "${_CABAL_VERSION_CACHE}"
155     }
156    
157 kosmikus 1.1 cabal-bootstrap() {
158     local setupmodule
159 dcoutts 1.14 local cabalpackage
160 kosmikus 1.1 if [[ -f "${S}/Setup.lhs" ]]; then
161     setupmodule="${S}/Setup.lhs"
162 slyfox 1.29 elif [[ -f "${S}/Setup.hs" ]]; then
163     setupmodule="${S}/Setup.hs"
164 kosmikus 1.1 else
165 slyfox 1.29 die "No Setup.lhs or Setup.hs found"
166 kosmikus 1.1 fi
167    
168 slyfox 1.31 if [[ -z "${CABAL_BOOTSTRAP}" && -z "${CABAL_FROM_GHC}" ]] && ! ghc-sanecabal "${CABAL_MIN_VERSION}"; then
169     eerror "The package dev-haskell/cabal is not correctly installed for"
170     eerror "the currently active version of ghc ($(ghc-version)). Please"
171     eerror "run haskell-updater or re-build dev-haskell/cabal."
172     die "cabal is not correctly installed"
173     fi
174    
175 kosmikus 1.1 # We build the setup program using the latest version of
176     # cabal that we have installed
177 slyfox 1.29 cabalpackage=Cabal-$(cabal-version)
178 dcoutts 1.14 einfo "Using cabal-$(cabal-version)."
179 slyfox 1.24
180     make_setup() {
181 slyfox 1.26 set -- -package "${cabalpackage}" --make "${setupmodule}" \
182 slyfox 1.24 ${GHC_BOOTSTRAP_FLAGS} \
183     "$@" \
184     -o setup
185 slyfox 1.27 echo $(ghc-getghc) ${HCFLAGS} "$@"
186 slyfox 1.26 $(ghc-getghc) "$@"
187 slyfox 1.24 }
188     if $(ghc-supports-shared-libraries); then
189 slyfox 1.30 # # some custom build systems might use external libraries,
190     # # for which we don't have shared libs, so keep static fallback
191     # bug #411789, http://hackage.haskell.org/trac/ghc/ticket/5743#comment:3
192 slyfox 1.35 # http://hackage.haskell.org/trac/ghc/ticket/7062
193     # http://hackage.haskell.org/trac/ghc/ticket/3072
194     # ghc does not set RPATH for extralibs, thus we do it ourselves by hands
195     einfo "Prepending $(ghc-libdir) to LD_LIBRARY_PATH"
196     if [[ ${CHOST} != *-darwin* ]]; then
197     LD_LIBRARY_PATH="$(ghc-libdir)${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
198     export LD_LIBRARY_PATH
199     else
200     DYLD_LIBRARY_PATH="$(ghc-libdir)${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
201     export DYLD_LIBRARY_PATH
202     fi
203     { make_setup -dynamic "$@" && ./setup --help >/dev/null; } ||
204 slyfox 1.30 make_setup "$@" || die "compiling ${setupmodule} failed"
205 slyfox 1.24 else
206     make_setup "$@" || die "compiling ${setupmodule} failed"
207     fi
208 kosmikus 1.1 }
209    
210 dcoutts 1.14 cabal-mksetup() {
211     local setupdir
212    
213     if [[ -n $1 ]]; then
214     setupdir=$1
215     else
216     setupdir=${S}
217     fi
218    
219     rm -f "${setupdir}"/Setup.{lhs,hs}
220    
221     echo 'import Distribution.Simple; main = defaultMainWithHooks defaultUserHooks' \
222 slyfox 1.29 > $setupdir/Setup.hs || die "failed to create default Setup.hs"
223 dcoutts 1.14 }
224    
225 kolmodin 1.21 cabal-hscolour() {
226 slyfox 1.26 set -- hscolour "$@"
227     echo ./setup "$@"
228     ./setup "$@" || die "setup hscolour failed"
229 kolmodin 1.21 }
230    
231 kosmikus 1.1 cabal-haddock() {
232 slyfox 1.26 set -- haddock "$@"
233     echo ./setup "$@"
234     ./setup "$@" || die "setup haddock failed"
235 kosmikus 1.1 }
236    
237 kolmodin 1.21 cabal-hscolour-haddock() {
238     # --hyperlink-source implies calling 'setup hscolour'
239 slyfox 1.26 set -- haddock --hyperlink-source
240     echo ./setup "$@"
241     ./setup "$@" --hyperlink-source || die "setup haddock --hyperlink-source failed"
242 kolmodin 1.21 }
243    
244 kosmikus 1.1 cabal-configure() {
245 slyfox 1.23 has "${EAPI:-0}" 0 1 2 && ! use prefix && EPREFIX=
246    
247 dcoutts 1.14 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then
248 slyfox 1.23 cabalconf="${cabalconf} --with-haddock=${EPREFIX}/usr/bin/haddock"
249 dcoutts 1.14 fi
250 kosmikus 1.1 if [[ -n "${CABAL_USE_PROFILE}" ]] && use profile; then
251 dcoutts 1.2 cabalconf="${cabalconf} --enable-library-profiling"
252 kosmikus 1.1 fi
253 slyfox 1.23 if [[ -n "${CABAL_USE_ALEX}" ]]; then
254     cabalconf="${cabalconf} --with-alex=${EPREFIX}/usr/bin/alex"
255     fi
256    
257     if [[ -n "${CABAL_USE_HAPPY}" ]]; then
258     cabalconf="${cabalconf} --with-happy=${EPREFIX}/usr/bin/happy"
259     fi
260    
261     if [[ -n "${CABAL_USE_C2HS}" ]]; then
262     cabalconf="${cabalconf} --with-c2hs=${EPREFIX}/usr/bin/c2hs"
263     fi
264     if [[ -n "${CABAL_USE_CPPHS}" ]]; then
265     cabalconf="${cabalconf} --with-cpphs=${EPREFIX}/usr/bin/cpphs"
266     fi
267 slyfox 1.32 if [[ -n "${CABAL_TEST_SUITE}" ]]; then
268     cabalconf="${cabalconf} $(use_enable test tests)"
269     fi
270 slyfox 1.23
271 slyfox 1.27 local option
272     for option in ${HCFLAGS}
273     do
274     cabalconf+=" --ghc-option=$option"
275     done
276    
277 dcoutts 1.6 # Building GHCi libs on ppc64 causes "TOC overflow".
278     if use ppc64; then
279 dcoutts 1.5 cabalconf="${cabalconf} --disable-library-for-ghci"
280     fi
281 kosmikus 1.1
282 slyfox 1.24 # currently cabal does not respect CFLAGS and LDFLAGS on it's own (bug #333217)
283     # so translate LDFLAGS to ghc parameters (without filtering)
284     local flag
285     for flag in $LDFLAGS; do cabalconf="${cabalconf} --ghc-option=-optl$flag"; done
286    
287 slyfox 1.29 # disable executable stripping for the executables, as portage will
288     # strip by itself, and pre-stripping gives a QA warning.
289     # cabal versions previous to 1.4 does not strip executables, and does
290     # not accept the flag.
291     # this fixes numerous bugs, amongst them;
292     # bug #251881, bug #251882, bug #251884, bug #251886, bug #299494
293     cabalconf="${cabalconf} --disable-executable-stripping"
294    
295     cabalconf="${cabalconf} --docdir=${EPREFIX}/usr/share/doc/${PF}"
296     # As of Cabal 1.2, configure is quite quiet. For diagnostic purposes
297     # it's better if the configure chatter is in the build logs:
298     cabalconf="${cabalconf} --verbose"
299 dcoutts 1.11
300 slyfox 1.24 # We build shared version of our Cabal where ghc ships it's shared
301     # version of it. We will link ./setup as dynamic binary againt Cabal later.
302     [[ ${CATEGORY}/${PN} == "dev-haskell/cabal" ]] && \
303     $(ghc-supports-shared-libraries) && \
304     cabalconf="${cabalconf} --enable-shared"
305    
306 slyfox 1.35 if $(ghc-supports-shared-libraries); then
307     # maybe a bit lower
308     if version_is_at_least "7.7.20121114" "$(ghc-version)"; then
309     cabalconf="${cabalconf} --enable-shared"
310     fi
311     fi
312    
313 slyfox 1.26 set -- configure \
314 slyfox 1.23 --ghc --prefix="${EPREFIX}"/usr \
315 kosmikus 1.1 --with-compiler="$(ghc-getghc)" \
316     --with-hc-pkg="$(ghc-getghcpkg)" \
317 slyfox 1.23 --prefix="${EPREFIX}"/usr \
318     --libdir="${EPREFIX}"/usr/$(get_libdir) \
319 dcoutts 1.11 --libsubdir=${P}/ghc-$(ghc-version) \
320 slyfox 1.23 --datadir="${EPREFIX}"/usr/share/ \
321 dcoutts 1.11 --datasubdir=${P}/ghc-$(ghc-version) \
322 kosmikus 1.1 ${cabalconf} \
323 kosmikus 1.8 ${CABAL_CONFIGURE_FLAGS} \
324 slyfox 1.24 ${CABAL_EXTRA_CONFIGURE_FLAGS} \
325 slyfox 1.26 "$@"
326     echo ./setup "$@"
327     ./setup "$@" || die "setup configure failed"
328 kosmikus 1.1 }
329    
330     cabal-build() {
331 dcoutts 1.14 unset LANG LC_ALL LC_MESSAGES
332 slyfox 1.27 set -- build ${CABAL_EXTRA_BUILD_FLAGS} "$@"
333 slyfox 1.26 echo ./setup "$@"
334     ./setup "$@" \
335 kosmikus 1.1 || die "setup build failed"
336     }
337    
338     cabal-copy() {
339 slyfox 1.23 has "${EAPI:-0}" 0 1 2 && ! use prefix && ED=${D}
340    
341 slyfox 1.26 set -- copy --destdir="${D}" "$@"
342     echo ./setup "$@"
343     ./setup "$@" || die "setup copy failed"
344 kosmikus 1.1
345     # cabal is a bit eager about creating dirs,
346     # so remove them if they are empty
347 slyfox 1.23 rmdir "${ED}/usr/bin" 2> /dev/null
348 kosmikus 1.1 }
349    
350     cabal-pkg() {
351 kosmikus 1.9 # This does not actually register since we're using true instead
352 slyfox 1.29 # of ghc-pkg. So it just leaves the .conf file and we can
353 kosmikus 1.1 # register that ourselves (if it exists).
354 dcoutts 1.2
355 dcoutts 1.4 if [[ -n ${CABAL_HAS_LIBRARIES} ]]; then
356 slyfox 1.29 # Newer cabal can generate a package conf for us:
357     ./setup register --gen-pkg-config="${T}/${P}.conf"
358     ghc-setup-pkg "${T}/${P}.conf"
359     ghc-install-pkg
360 kosmikus 1.1 fi
361     }
362    
363 kolmodin 1.13 # Some cabal libs are bundled along with some versions of ghc
364     # eg filepath-1.0 comes with ghc-6.6.1
365     # by putting CABAL_CORE_LIB_GHC_PV="6.6.1" in an ebuild we are declaring that
366     # when building with this version of ghc, the ebuild is a dummy that is it will
367     # install no files since the package is already included with ghc.
368     # However portage still records the dependency and we can upgrade the package
369     # to a later one that's not included with ghc.
370     # You can also put a space separated list, eg CABAL_CORE_LIB_GHC_PV="6.6 6.6.1".
371     cabal-is-dummy-lib() {
372     for version in ${CABAL_CORE_LIB_GHC_PV[*]}; do
373 slyfox 1.33 [[ "$(ghc-version)" == ${version} ]] && return 0
374 kolmodin 1.13 done
375     return 1
376     }
377    
378 kosmikus 1.1 # exported function: check if cabal is correctly installed for
379     # the currently active ghc (we cannot guarantee this with portage)
380     haskell-cabal_pkg_setup() {
381 dcoutts 1.4 if [[ -z "${CABAL_HAS_BINARIES}" ]] && [[ -z "${CABAL_HAS_LIBRARIES}" ]]; then
382 slyfox 1.29 eqawarn "QA Notice: Neither bin nor lib are in CABAL_FEATURES."
383 dcoutts 1.4 fi
384 dcoutts 1.3 if [[ -n "${CABAL_UNKNOWN}" ]]; then
385 slyfox 1.29 eqawarn "QA Notice: Unknown entry in CABAL_FEATURES: ${CABAL_UNKNOWN}"
386 dcoutts 1.3 fi
387 kolmodin 1.13 if cabal-is-dummy-lib; then
388     einfo "${P} is included in ghc-${CABAL_CORE_LIB_GHC_PV}, nothing to install."
389     fi
390 kosmikus 1.1 }
391    
392 kolmodin 1.19 haskell-cabal_src_configure() {
393 slyfox 1.29 cabal-is-dummy-lib && return
394    
395     pushd "${S}" > /dev/null
396 kolmodin 1.19
397 slyfox 1.29 cabal-bootstrap
398 slyfox 1.22
399 slyfox 1.29 cabal-configure "$@"
400 kolmodin 1.19
401 slyfox 1.29 popd > /dev/null
402 kolmodin 1.19 }
403    
404     # exported function: nice alias
405     cabal_src_configure() {
406     haskell-cabal_src_configure "$@"
407     }
408    
409 kosmikus 1.1 # exported function: cabal-style bootstrap configure and compile
410     cabal_src_compile() {
411 slyfox 1.24 # it's a common mistake when one bumps ebuild to EAPI="2" (and upper)
412     # and forgets to separate src_compile() to src_configure()/src_compile().
413     # Such error leads to default src_configure and we lose all passed flags.
414     if ! has "${EAPI:-0}" 0 1; then
415     local passed_flag
416     for passed_flag in "$@"; do
417     [[ ${passed_flag} == --flags=* ]] && \
418 slyfox 1.29 eqawarn "QA Notice: Cabal option '${passed_flag}' has effect only in src_configure()"
419 slyfox 1.24 done
420     fi
421    
422 slyfox 1.29 cabal-is-dummy-lib && return
423    
424     has src_configure ${HASKELL_CABAL_EXPF} || haskell-cabal_src_configure "$@"
425     cabal-build
426 kosmikus 1.1
427 slyfox 1.29 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then
428     if [[ -n "${CABAL_USE_HSCOLOUR}" ]] && use hscolour; then
429     # hscolour and haddock
430     cabal-hscolour-haddock
431 kolmodin 1.21 else
432 slyfox 1.29 # just haddock
433     cabal-haddock
434     fi
435     else
436     if [[ -n "${CABAL_USE_HSCOLOUR}" ]] && use hscolour; then
437     # just hscolour
438     cabal-hscolour
439 kolmodin 1.13 fi
440 kosmikus 1.1 fi
441     }
442 kolmodin 1.16
443 kosmikus 1.1 haskell-cabal_src_compile() {
444 kolmodin 1.19 pushd "${S}" > /dev/null
445    
446     cabal_src_compile "$@"
447    
448     popd > /dev/null
449     }
450    
451     haskell-cabal_src_test() {
452     pushd "${S}" > /dev/null
453    
454 kolmodin 1.20 if cabal-is-dummy-lib; then
455     einfo ">>> No tests for dummy library: ${CATEGORY}/${PF}"
456     else
457     einfo ">>> Test phase [cabal test]: ${CATEGORY}/${PF}"
458 slyfox 1.26 set -- test "$@"
459     echo ./setup "$@"
460     ./setup "$@" || die "cabal test failed"
461 kolmodin 1.20 fi
462 kolmodin 1.19
463     popd > /dev/null
464 kosmikus 1.1 }
465    
466     # exported function: cabal-style copy and register
467     cabal_src_install() {
468 slyfox 1.23 has "${EAPI:-0}" 0 1 2 && ! use prefix && EPREFIX=
469    
470 slyfox 1.29 if ! cabal-is-dummy-lib; then
471 kolmodin 1.13 cabal-copy
472     cabal-pkg
473 slyfox 1.29 fi
474 kosmikus 1.1
475 slyfox 1.29 # create a dummy local package conf file for haskell-updater
476     # if it does not exist (dummy libraries and binaries w/o libraries)
477     local ghc_confdir_with_prefix="$(ghc-confdir)"
478     # remove EPREFIX
479     dodir ${ghc_confdir_with_prefix#${EPREFIX}}
480     local conf_file="${D}/$(ghc-confdir)/$(ghc-localpkgconf)"
481     [[ -e $conf_file ]] || echo '[]' > "$conf_file" || die
482 slyfox 1.33
483     # make sure installed packages do not destroy ghc's
484     # bundled packages
485     local initial_pkg_db=${ROOT}/$(ghc-libdir)/package.conf.d.initial
486     if [[ -e ${initial_pkg_db} ]]; then
487     local checked_pkg
488     for checked_pkg in $(ghc-listpkg "${conf_file}")
489     do
490     local initial_pkg
491     for initial_pkg in $(ghc-listpkg "${initial_pkg_db}"); do
492     if [[ ${checked_pkg} = ${initial_pkg} ]]; then
493     eerror "Package ${checked_pkg} is shipped with $(ghc-version)."
494     eerror "Ebuild author forgot CABAL_CORE_LIB_GHC_PV entry."
495     eerror "Found in ${initial_pkg_db}."
496     die
497     fi
498     done
499     done
500     fi
501 kosmikus 1.1 }
502 kolmodin 1.19
503 kosmikus 1.1 haskell-cabal_src_install() {
504 kolmodin 1.19 pushd "${S}" > /dev/null
505    
506 kosmikus 1.1 cabal_src_install
507 kolmodin 1.19
508     popd > /dev/null
509 kosmikus 1.1 }
510    
511 kolmodin 1.19 # ebuild.sh:use_enable() taken as base
512     #
513     # Usage examples:
514     #
515     # CABAL_CONFIGURE_FLAGS=$(cabal_flag gui)
516     # leads to "--flags=gui" or "--flags=-gui" (useflag 'gui')
517     #
518     # CABAL_CONFIGURE_FLAGS=$(cabal_flag gtk gui)
519     # also leads to "--flags=gui" or " --flags=-gui" (useflag 'gtk')
520     #
521     cabal_flag() {
522     if [[ -z "$1" ]]; then
523     echo "!!! cabal_flag() called without a parameter." >&2
524     echo "!!! cabal_flag() <USEFLAG> [<cabal_flagname>]" >&2
525     return 1
526     fi
527    
528     local UWORD=${2:-$1}
529    
530     if use "$1"; then
531     echo "--flags=${UWORD}"
532     else
533     echo "--flags=-${UWORD}"
534     fi
535    
536     return 0
537     }

  ViewVC Help
Powered by ViewVC 1.1.20